-- write SQL queries to find

use University;

-- ex1. student's name and surname
select name, surname 
from Students;

-- ex2. student's name and surname for the students 
-- of the bachelor degree
select name, surname 
from Students
where program = 'bachelor';

-- ex3. student's name and surname for the students 
-- of the bachelor degree at the 2nd year
select studentID, name as studentName, surname as studentSurname
from Students
where program = 'bachelor' and year = 2;

-- ex4. for each course its name and the 
-- ralated professor name
select c.title, t.surname, t.name
from Courses as c join Teachers as t on c.teacher = t.code;

-- ex 5. the total number of exams
select count(*) as totalExams
from Exams;

-- ex6. for each student the name and surname and
-- its total number of exam
select s.name, s.surname, count(*) as totalExame
from Exams as e join Students as s on e.student = s.studentID
group by s.studentID, s.name, s.surname;
 
-- ex7. for each student the name and surname and
-- its total number of exam for the students which passed more 
-- than one exam
select s.name, s.surname, count(*) as totalExame
from Exams as e join Students as s on e.student = s.studentID
group by s.studentID, s.name, s.surname
having count(*) > 1;

-- ex8. for each student the name, surname and its average mark
select s.name, s.surname, avg(mark) as avgMark
from Exams as e join Students as s on e.student = s.studentID
group by s.studentID, s.name, s.surname;

-- ex9. studentID and surname of the students who did the exam 
-- of courses containing the word 'database' in the title
select s.studentID, s.surname
from Exams as e join Students as s on e.student = s.studentID 
join Courses as c on e.course = c.code
where c.title like '%database%';

-- ex10. surname and name of all people 
-- sorted by surname, name

select surname, name from Students
union
select surname, name from Teachers
order by surname;

-- ex11. surname and name of  NOT full professors 
-- who are supervisors of bachelor thesis 
select t.name, t.surname
from Teachers as t join Students as s on s.supervisor = t.code
where s.program = 'bachelor' and t.role <> 'full';

-- ex12. surname and name of full professors who are NOT supervisors 
-- of bachelor thesis 
select t.name, t.surname
from Teachers as t join Students as s on s.supervisor = t.code
where t.role = 'full' and t.code not in (
	select s.supervisor
    from Students s
    where s.program='bachelor'
	);
    
-- ex13. list of students with surname, name and studentID 
-- with exam in databases with a mark greater that one of their tutor
